Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Executor.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Executor.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Executor.cs	(revision 6725)
@@ -29,17 +29,17 @@
 namespace HeuristicLab.Clients.Hive.SlaveCore {
   /// <summary>
-  /// The executor runs in the appdomain and handles the execution of an Hive job.
+  /// The executor runs in the appdomain and handles the execution of an Hive task.
   /// </summary>
   public class Executor : MarshalByRefObject, IDisposable {
-    private bool wasJobAborted = false;
+    private bool wasTaskAborted = false;
     private AutoResetEvent pauseStopSem = new AutoResetEvent(false);
-    private AutoResetEvent startJobSem = new AutoResetEvent(false); // block start method call
-    private AutoResetEvent jobStartedSem = new AutoResetEvent(false); // make pause or stop wait until start is finished
+    private AutoResetEvent startTaskSem = new AutoResetEvent(false); // block start method call
+    private AutoResetEvent taskStartedSem = new AutoResetEvent(false); // make pause or stop wait until start is finished
     private ExecutorQueue executorQueue;
-    private bool jobDataInvalid = false; // if true, the jobdata is not sent when the job is failed
-    private IJob job;
+    private bool taskDataInvalid = false; // if true, the jobdata is not sent when the task is failed
+    private ITask task;
     private DateTime creationTime;
 
-    public Guid JobId { get; set; }
+    public Guid TaskId { get; set; }
     public int CoresNeeded { get; set; }
     public int MemoryNeeded { get; set; }
@@ -63,9 +63,9 @@
 
     private ExecutionState ExecutionState {
-      get { return job != null ? job.ExecutionState : HeuristicLab.Core.ExecutionState.Stopped; }
+      get { return task != null ? task.ExecutionState : HeuristicLab.Core.ExecutionState.Stopped; }
     }
 
     public TimeSpan ExecutionTime {
-      get { return job != null ? job.ExecutionTime : new TimeSpan(0, 0, 0); }
+      get { return task != null ? task.ExecutionTime : new TimeSpan(0, 0, 0); }
     }
 
@@ -79,20 +79,20 @@
       try {
         creationTime = DateTime.Now;
-        job = PersistenceUtil.Deserialize<IJob>(serializedJob);
+        task = PersistenceUtil.Deserialize<ITask>(serializedJob);
 
         RegisterJobEvents();
 
-        job.Start();
-        if (!startJobSem.WaitOne(Settings.Default.ExecutorSemTimeouts)) {
-          jobDataInvalid = true;
-          throw new TimeoutException("Timeout when starting the job. JobStarted event was not fired.");
+        task.Start();
+        if (!startTaskSem.WaitOne(Settings.Default.ExecutorSemTimeouts)) {
+          taskDataInvalid = true;
+          throw new TimeoutException("Timeout when starting the task. TaskStarted event was not fired.");
         }
       }
       catch (Exception e) {
         this.CurrentException = e;
-        Job_JobFailed(this, new EventArgs<Exception>(e));
+        Task_TaskFailed(this, new EventArgs<Exception>(e));
       }
       finally {
-        jobStartedSem.Set();
+        taskStartedSem.Set();
       }
     }
@@ -100,20 +100,20 @@
     public void Pause() {
       IsPausing = true;
-      // wait until job is started. if this does not happen, the Task is null an we give up
-      jobStartedSem.WaitOne(Settings.Default.ExecutorSemTimeouts);
-      if (job == null) {
-        CurrentException = new Exception("Pausing job " + this.JobId + ": Task is null");
+      // wait until task is started. if this does not happen, the Task is null an we give up
+      taskStartedSem.WaitOne(Settings.Default.ExecutorSemTimeouts);
+      if (task == null) {
+        CurrentException = new Exception("Pausing task " + this.TaskId + ": Task is null");
         executorQueue.AddMessage(ExecutorMessageType.ExceptionOccured);
         return;
       }
 
-      if (job.ExecutionState == ExecutionState.Started) {
+      if (task.ExecutionState == ExecutionState.Started) {
         try {
-          job.Pause();
+          task.Pause();
           //we need to block the pause...
           pauseStopSem.WaitOne();
         }
         catch (Exception ex) {
-          CurrentException = new Exception("Error pausing job " + this.JobId + ": " + ex.ToString());
+          CurrentException = new Exception("Error pausing task " + this.TaskId + ": " + ex.ToString());
           executorQueue.AddMessage(ExecutorMessageType.ExceptionOccured);
         }
@@ -123,19 +123,19 @@
     public void Stop() {
       IsStopping = true;
-      // wait until job is started. if this does not happen, the Task is null an we give up
-      jobStartedSem.WaitOne(Settings.Default.ExecutorSemTimeouts);
-      if (job == null) {
-        CurrentException = new Exception("Stopping job " + this.JobId + ": Task is null");
+      // wait until task is started. if this does not happen, the Task is null an we give up
+      taskStartedSem.WaitOne(Settings.Default.ExecutorSemTimeouts);
+      if (task == null) {
+        CurrentException = new Exception("Stopping task " + this.TaskId + ": Task is null");
         executorQueue.AddMessage(ExecutorMessageType.ExceptionOccured);
       }
-      wasJobAborted = true;
+      wasTaskAborted = true;
 
       if ((ExecutionState == ExecutionState.Started) || (ExecutionState == ExecutionState.Paused)) {
         try {
-          job.Stop();
+          task.Stop();
           pauseStopSem.WaitOne();
         }
         catch (Exception ex) {
-          CurrentException = new Exception("Error stopping job " + this.JobId + ": " + ex.ToString());
+          CurrentException = new Exception("Error stopping task " + this.TaskId + ": " + ex.ToString());
           executorQueue.AddMessage(ExecutorMessageType.ExceptionOccured);
         }
@@ -144,70 +144,70 @@
 
     private void RegisterJobEvents() {
-      job.JobStopped += new EventHandler(Job_JobStopped);
-      job.JobFailed += new EventHandler(Job_JobFailed);
-      job.JobPaused += new EventHandler(Job_JobPaused);
-      job.JobStarted += new EventHandler(Job_JobStarted);
+      task.TaskStopped += new EventHandler(Task_TaskStopped);
+      task.TaskFailed += new EventHandler(Task_TaskFailed);
+      task.TaskPaused += new EventHandler(Task_TaskPaused);
+      task.TaskStarted += new EventHandler(Task_TaskStarted);
     }
 
     private void DeregisterJobEvents() {
-      job.JobStopped -= new EventHandler(Job_JobStopped);
-      job.JobFailed -= new EventHandler(Job_JobFailed);
-      job.JobPaused -= new EventHandler(Job_JobPaused);
-      job.JobStarted -= new EventHandler(Job_JobStarted);
+      task.TaskStopped -= new EventHandler(Task_TaskStopped);
+      task.TaskFailed -= new EventHandler(Task_TaskFailed);
+      task.TaskPaused -= new EventHandler(Task_TaskPaused);
+      task.TaskStarted -= new EventHandler(Task_TaskStarted);
     }
 
     #region Task Events
-    private void Job_JobFailed(object sender, EventArgs e) {
+    private void Task_TaskFailed(object sender, EventArgs e) {
       IsStopping = true;
       EventArgs<Exception> ex = (EventArgs<Exception>)e;
       CurrentException = ex.Value;
-      executorQueue.AddMessage(ExecutorMessageType.JobFailed);
-    }
-
-    private void Job_JobStopped(object sender, EventArgs e) {
+      executorQueue.AddMessage(ExecutorMessageType.TaskFailed);
+    }
+
+    private void Task_TaskStopped(object sender, EventArgs e) {
       IsStopping = true;
-      if (wasJobAborted) {
+      if (wasTaskAborted) {
         pauseStopSem.Set();
       }
-      executorQueue.AddMessage(ExecutorMessageType.JobStopped);
-    }
-
-    private void Job_JobPaused(object sender, EventArgs e) {
+      executorQueue.AddMessage(ExecutorMessageType.TaskStopped);
+    }
+
+    private void Task_TaskPaused(object sender, EventArgs e) {
       IsPausing = true;
       pauseStopSem.Set();
-      executorQueue.AddMessage(ExecutorMessageType.JobPaused);
-    }
-
-    private void Job_JobStarted(object sender, EventArgs e) {
-      startJobSem.Set();
-      executorQueue.AddMessage(ExecutorMessageType.JobStarted);
+      executorQueue.AddMessage(ExecutorMessageType.TaskPaused);
+    }
+
+    private void Task_TaskStarted(object sender, EventArgs e) {
+      startTaskSem.Set();
+      executorQueue.AddMessage(ExecutorMessageType.TaskStarted);
     }
     #endregion
 
-    public TaskData GetJobData() {
-      if (jobDataInvalid) return null;
-
-      if (job.ExecutionState == ExecutionState.Started) {
+    public TaskData GetTaskData() {
+      if (taskDataInvalid) return null;
+
+      if (task.ExecutionState == ExecutionState.Started) {
         throw new InvalidStateException("Task is still running");
       } else {
-        TaskData jobData = new TaskData();
-        if (job == null) {
-          //send empty job and save exception
-          jobData.Data = PersistenceUtil.Serialize(new TaskData());
+        TaskData taskData = new TaskData();
+        if (task == null) {
+          //send empty task and save exception
+          taskData.Data = PersistenceUtil.Serialize(new TaskData());
           if (CurrentException == null) {
-            CurrentException = new Exception("Task with id " + this.JobId + " is null, sending empty job");
+            CurrentException = new Exception("Task with id " + this.TaskId + " is null, sending empty task");
           }
         } else {
-          jobData.Data = PersistenceUtil.Serialize(job);
-        }
-        jobData.TaskId = JobId;
-        return jobData;
+          taskData.Data = PersistenceUtil.Serialize(task);
+        }
+        taskData.TaskId = TaskId;
+        return taskData;
       }
     }
 
     public void Dispose() {
-      if (job != null)
+      if (task != null)
         DeregisterJobEvents();
-      job = null;
+      task = null;
     }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/ExecutorMessage.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/ExecutorMessage.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/ExecutorMessage.cs	(revision 6725)
@@ -26,8 +26,8 @@
   [Serializable]
   public enum ExecutorMessageType {
-    JobStarted,
-    JobPaused,
-    JobStopped,
-    JobFailed,
+    TaskStarted,
+    TaskPaused,
+    TaskStopped,
+    TaskFailed,
     StopExecutorMonitoringThread,
     ExceptionOccured
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 6725)
@@ -101,18 +101,18 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Exceptions\JobFailedException.cs" />
+    <Compile Include="Exceptions\TaskFailedException.cs" />
     <Compile Include="Manager\ConfigManager.cs" />
     <Compile Include="Exceptions\SerializationException.cs" />
     <Compile Include="Exceptions\OutOfMemoryException.cs" />
-    <Compile Include="Exceptions\JobNotRunningException.cs" />
-    <Compile Include="Exceptions\JobAlreadyRunningException.cs" />
-    <Compile Include="Exceptions\JobNotFoundException.cs" />
-    <Compile Include="Exceptions\JobNotDataFoundException.cs" />
+    <Compile Include="Exceptions\TaskNotRunningException.cs" />
+    <Compile Include="Exceptions\TaskAlreadyRunningException.cs" />
+    <Compile Include="Exceptions\TaskNotFoundException.cs" />
+    <Compile Include="Exceptions\TaskNotDataFoundException.cs" />
     <Compile Include="ExecutorMessage.cs" />
     <Compile Include="ExecutorQueue.cs" />
     <Compile Include="IPluginProvider.cs" />
-    <Compile Include="Manager\JobManager.cs" />
+    <Compile Include="Manager\TaskManager.cs" />
     <Compile Include="Exceptions\OutOfCoresException.cs" />
-    <Compile Include="Exceptions\JobNotStartedException.cs" />
+    <Compile Include="Exceptions\AppDomainNotCreatedException.cs" />
     <Compile Include="SlaveClientCom.cs" />
     <Compile Include="Core.cs" />
@@ -121,5 +121,5 @@
     <Compile Include="Manager\HeartbeatManager.cs" />
     <Compile Include="Exceptions\InvalidStateException.cs" />
-    <Compile Include="JobStatus.cs" />
+    <Compile Include="TaskStatus.cs" />
     <Compile Include="MessageQueue.cs" />
     <Compile Include="NetworkEnum.cs" />
@@ -133,5 +133,5 @@
     <Compile Include="ServiceContracts\ISlaveCommunicationCallbacks.cs" />
     <Compile Include="SlaveCommunicationService.cs" />
-    <Compile Include="SlaveJob.cs" />
+    <Compile Include="SlaveTask.cs" />
     <Compile Include="SlaveStatusInfo.cs" />
     <Compile Include="StatusCommons.cs" />
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 6725)
@@ -42,5 +42,5 @@
     /// </summary>
     public bool Asleep { get; set; }
-    private JobManager jobManager;
+    private TaskManager jobManager;
     private Slave slave;
     private PerformanceCounter cpuCounter;
@@ -49,5 +49,5 @@
     /// Constructor for the singleton, must recover Guid, Calendar, ...
     /// </summary>
-    public ConfigManager(JobManager jobManager) {
+    public ConfigManager(TaskManager jobManager) {
       this.jobManager = jobManager;
       cpuCounter = new PerformanceCounter();
@@ -95,12 +95,12 @@
       st.Asleep = this.Asleep;
 
-      st.JobsStarted = SlaveStatusInfo.JobsStarted;
-      st.JobsAborted = SlaveStatusInfo.JobsAborted;
-      st.JobsFinished = SlaveStatusInfo.JobsFinished;
-      st.JobsFetched = SlaveStatusInfo.JobsFetched;
-      st.JobsFailed = SlaveStatusInfo.JobsFailed;
+      st.JobsStarted = SlaveStatusInfo.TasksStarted;
+      st.JobsAborted = SlaveStatusInfo.TasksAborted;
+      st.JobsFinished = SlaveStatusInfo.TasksFinished;
+      st.JobsFetched = SlaveStatusInfo.TasksFetched;
+      st.JobsFailed = SlaveStatusInfo.TasksFailed;
       st.ExceptionsOccured = SlaveStatusInfo.ExceptionsOccured;
 
-      st.Jobs = jobManager.GetExecutionTimes().Select(x => new JobStatus { JobId = x.Key, ExecutionTime = x.Value }).ToList();
+      st.Jobs = jobManager.GetExecutionTimes().Select(x => new TaskStatus { TaskId = x.Key, ExecutionTime = x.Value }).ToList();
 
       return st;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/PluginManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/PluginManager.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/PluginManager.cs	(revision 6725)
@@ -133,14 +133,14 @@
     /// <summary>
     /// Updates the plugin cache with missing plugins and 
-    /// then copies the required plugins for the job.
+    /// then copies the required plugins for the task.
     /// </summary>        
-    public void PreparePlugins(Task job, out string configFileName) {
+    public void PreparePlugins(Task task, out string configFileName) {
       lock (locker) {
-        log.LogMessage("Fetching plugins for job " + job.Id);
+        log.LogMessage("Fetching plugins for task " + task.Id);
 
         List<Guid> missingGuids = new List<Guid>();
         List<Plugin> neededPlugins = new List<Plugin>();
         lock (cachedPluginsGuids) {
-          foreach (Guid pluginId in job.PluginsNeededIds) {
+          foreach (Guid pluginId in task.PluginsNeededIds) {
             Plugin plugin = pluginService.GetPlugin(pluginId);
             if (plugin != null) {
@@ -168,9 +168,9 @@
             DoUpdateRun();
           }
-          CopyPluginsForJob(neededPlugins, job.Id, out configFileName);
+          CopyPluginsForJob(neededPlugins, task.Id, out configFileName);
         } else {
           configFileName = "";
         }
-        log.LogMessage(string.Format("Fetched {0} plugins for job {1}", missingGuids.Count, job.Id));
+        log.LogMessage(string.Format("Fetched {0} plugins for task {1}", missingGuids.Count, task.Id));
       }
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/TaskManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/TaskManager.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/TaskManager.cs	(revision 6725)
@@ -0,0 +1,335 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+
+  /// <summary>
+  /// Holds a list of slave tasks and manages access to this list. 
+  /// Forwards events from SlaveTask and forwards commands to SlaveTask. 
+  /// </summary>
+  public class TaskManager {
+    private static ReaderWriterLockSlim slaveTasksLocker = new ReaderWriterLockSlim(LockRecursionPolicy.SupportsRecursion);
+    private Dictionary<Guid, SlaveTask> slaveTasks;
+    private ILog log;
+    private PluginManager pluginManager;
+
+    public int TaskCount {
+      get {
+        slaveTasksLocker.EnterReadLock();
+        try {
+          return slaveTasks.Count;
+        }
+        finally { slaveTasksLocker.ExitReadLock(); }
+      }
+    }
+
+    public Guid[] TaskIds {
+      get {
+        slaveTasksLocker.EnterReadLock();
+        try {
+          return slaveTasks.Keys.ToArray();
+        }
+        finally { slaveTasksLocker.ExitReadLock(); }
+      }
+    }
+
+    public TaskManager(PluginManager pluginCache, ILog log) {
+      this.pluginManager = pluginCache;
+      this.log = log;
+      this.slaveTasks = new Dictionary<Guid, SlaveTask>();
+    }
+
+    #region Task Control methods
+    public void StartTaskAsync(Task task, TaskData taskData) {
+      SlaveTask slaveTask = null;
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        if (slaveTasks.ContainsKey(task.Id)) {
+          SlaveStatusInfo.IncrementExceptionOccured();
+          throw new TaskAlreadyRunningException(task.Id);
+        } else {
+          slaveTask = new SlaveTask(pluginManager, task.CoresNeeded, log);
+          AddSlaveTask(task, slaveTask);
+          SlaveStatusInfo.IncrementTasksFetched();
+        }
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+
+      if (slaveTask != null) {
+        try {
+          slaveTask.StartJobAsync(task, taskData);
+        }
+        catch (Exception) {
+          RemoveSlaveTask(task.Id, slaveTask); // clean up and rethrow
+          slaveTask.DisposeAppDomain();
+          throw;
+        }
+      }
+    }
+
+    public void PauseTaskAsync(Guid taskId) {
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        if (!slaveTasks.ContainsKey(taskId)) throw new TaskNotRunningException(taskId);
+        SlaveTask slaveTask = slaveTasks[taskId];
+        slaveTask.PauseTask();
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+    }
+
+    public void StopTaskAsync(Guid taskId) {
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        if (!slaveTasks.ContainsKey(taskId)) throw new TaskNotRunningException(taskId);
+        SlaveTask slaveTask = slaveTasks[taskId];
+        slaveTask.StopTask();
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+    }
+
+    public void AbortTask(Guid taskId) {
+      SlaveTask slaveTask = null;
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        if (!slaveTasks.ContainsKey(taskId)) throw new TaskNotRunningException(taskId);
+        slaveTask = slaveTasks[taskId];
+        if (!slaveTask.IsPrepared) throw new AppDomainNotCreatedException();
+        RemoveSlaveTask(taskId, slaveTask);
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+      slaveTask.DisposeAppDomain();
+      SlaveStatusInfo.IncrementTasksAborted();
+      OnTaskAborted(slaveTask);
+    }
+
+    public void PauseAllTasksAsync() {
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        foreach (var slaveTask in slaveTasks.Values) {
+          slaveTask.PauseTask();
+        }
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+    }
+
+    public void StopAllTasksAsync() {
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        foreach (var slaveTask in slaveTasks.Values) {
+          slaveTask.StopTask();
+        }
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+    }
+
+    public void AbortAllTasks() {
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        foreach (var slaveTask in slaveTasks.Values.ToArray()) {
+          AbortTask(slaveTask.TaskId);
+        }
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+    }
+    #endregion
+
+    #region Add/Remove SlaveTask
+    private void AddSlaveTask(Task task, SlaveTask slaveTask) {
+      slaveTasksLocker.EnterWriteLock();
+      try {
+        slaveTasks.Add(task.Id, slaveTask);
+        RegisterSlaveTaskEvents(slaveTask);
+      }
+      finally { slaveTasksLocker.ExitWriteLock(); }
+    }
+
+    private void RemoveSlaveTask(Guid taskId, SlaveTask slaveTask) {
+      slaveTasksLocker.EnterWriteLock();
+      try {
+        slaveTasks.Remove(taskId);
+        DeregisterSlaveTaskEvents(slaveTask);
+      }
+      finally { slaveTasksLocker.ExitWriteLock(); }
+    }
+    #endregion
+
+    #region SlaveTask Events
+    private void RegisterSlaveTaskEvents(SlaveTask slaveTask) {
+      slaveTask.TaskStarted += new EventHandler<EventArgs<Guid>>(slaveTask_TaskStarted);
+      slaveTask.TaskPaused += new EventHandler<EventArgs<Guid>>(slaveTask_TaskPaused);
+      slaveTask.TaskStopped += new EventHandler<EventArgs<Guid>>(slaveTask_TaskStopped);
+      slaveTask.TaskFailed += new EventHandler<EventArgs<Guid, Exception>>(slaveTask_TaskFailed);
+      slaveTask.ExceptionOccured += new EventHandler<EventArgs<Guid, Exception>>(slaveTask_ExceptionOccured);
+    }
+
+    private void DeregisterSlaveTaskEvents(SlaveTask slaveTask) {
+      slaveTask.TaskStarted -= new EventHandler<EventArgs<Guid>>(slaveTask_TaskStarted);
+      slaveTask.TaskPaused -= new EventHandler<EventArgs<Guid>>(slaveTask_TaskPaused);
+      slaveTask.TaskStopped -= new EventHandler<EventArgs<Guid>>(slaveTask_TaskStopped);
+      slaveTask.TaskFailed -= new EventHandler<EventArgs<Guid, Exception>>(slaveTask_TaskFailed);
+      slaveTask.ExceptionOccured -= new EventHandler<EventArgs<Guid, Exception>>(slaveTask_ExceptionOccured);
+    }
+
+    private void slaveTask_TaskStarted(object sender, EventArgs<Guid> e) {
+      SlaveTask slaveTask;
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        slaveTask = slaveTasks[e.Value];
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+
+      SlaveStatusInfo.IncrementTasksStarted();
+      OnTaskStarted(slaveTask);
+    }
+
+    private void slaveTask_TaskPaused(object sender, EventArgs<Guid> e) {
+      SlaveTask slaveTask;
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        slaveTask = slaveTasks[e.Value];
+        RemoveSlaveTask(e.Value, slaveTask);
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+
+      TaskData taskData = null;
+      try {
+        taskData = slaveTask.GetTaskData();
+        if (taskData == null) throw new SerializationException();
+        SlaveStatusInfo.IncrementTasksFinished();
+        OnTaskPaused(slaveTask, taskData);
+      }
+      catch (Exception ex) {
+        RemoveSlaveTask(e.Value, slaveTask);
+        SlaveStatusInfo.IncrementTasksFailed();
+        OnTaskFailed(slaveTask, taskData, ex);
+      }
+    }
+
+    private void slaveTask_TaskStopped(object sender, EventArgs<Guid> e) {
+      SlaveTask slaveTask;
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        slaveTask = slaveTasks[e.Value];
+        RemoveSlaveTask(e.Value, slaveTask);
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+
+      TaskData taskData = null;
+      try {
+        taskData = slaveTask.GetTaskData();
+        if (taskData == null) throw new SerializationException();
+        SlaveStatusInfo.IncrementTasksFinished();
+        OnTaskStopped(slaveTask, taskData);
+      }
+      catch (Exception ex) {
+        RemoveSlaveTask(e.Value, slaveTask);
+        SlaveStatusInfo.IncrementTasksFailed();
+        OnTaskFailed(slaveTask, taskData, ex);
+      }
+    }
+
+    private void slaveTask_TaskFailed(object sender, EventArgs<Guid, Exception> e) {
+      SlaveTask slaveTask;
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        slaveTask = slaveTasks[e.Value];
+        RemoveSlaveTask(e.Value, slaveTask);
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+
+      TaskData taskData = null;
+      try {
+        taskData = slaveTask.GetTaskData();
+        if (taskData == null) throw new SerializationException();
+      }
+      catch { /* taskData will be null */ }
+      SlaveStatusInfo.IncrementTasksFailed();
+      OnTaskFailed(slaveTask, taskData, e.Value2);
+    }
+
+    private void slaveTask_ExceptionOccured(object sender, EventArgs<Guid, Exception> e) {
+      SlaveTask slaveTask;
+      slaveTasksLocker.EnterUpgradeableReadLock();
+      try {
+        slaveTask = slaveTasks[e.Value];
+        RemoveSlaveTask(e.Value, slaveTask);
+      }
+      finally { slaveTasksLocker.ExitUpgradeableReadLock(); }
+
+      SlaveStatusInfo.IncrementExceptionOccured();
+      OnExceptionOccured(slaveTask, e.Value2);
+    }
+    #endregion
+
+    #region EventHandler
+    public event EventHandler<EventArgs<SlaveTask>> TaskStarted;
+    private void OnTaskStarted(SlaveTask slaveTask) {
+      var handler = TaskStarted;
+      if (handler != null) handler(this, new EventArgs<SlaveTask>(slaveTask));
+    }
+
+    public event EventHandler<EventArgs<SlaveTask, TaskData>> TaskStopped;
+    private void OnTaskStopped(SlaveTask slaveTask, TaskData taskData) {
+      var handler = TaskStopped;
+      if (handler != null) handler(this, new EventArgs<SlaveTask, TaskData>(slaveTask, taskData));
+    }
+
+    public event EventHandler<EventArgs<SlaveTask, TaskData>> TaskPaused;
+    private void OnTaskPaused(SlaveTask slaveTask, TaskData taskData) {
+      var handler = TaskPaused;
+      if (handler != null) handler(this, new EventArgs<SlaveTask, TaskData>(slaveTask, taskData));
+    }
+
+    public event EventHandler<EventArgs<Tuple<SlaveTask, TaskData, Exception>>> TaskFailed;
+    private void OnTaskFailed(SlaveTask slaveTask, TaskData taskData, Exception exception) {
+      var handler = TaskFailed;
+      if (handler != null) handler(this, new EventArgs<Tuple<SlaveTask, TaskData, Exception>>(new Tuple<SlaveTask, TaskData, Exception>(slaveTask, taskData, exception)));
+    }
+
+    public event EventHandler<EventArgs<SlaveTask, Exception>> ExceptionOccured;
+    private void OnExceptionOccured(SlaveTask slaveTask, Exception exception) {
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<SlaveTask, Exception>(slaveTask, exception));
+    }
+
+    public event EventHandler<EventArgs<SlaveTask>> TaskAborted;
+    private void OnTaskAborted(SlaveTask slaveTask) {
+      var handler = TaskAborted;
+      if (handler != null) handler(this, new EventArgs<SlaveTask>(slaveTask));
+    }
+    #endregion
+
+    public Dictionary<Guid, TimeSpan> GetExecutionTimes() {
+      slaveTasksLocker.EnterReadLock();
+      try {
+        return slaveTasks.ToDictionary(x => x.Key, x => x.Value.ExecutionTime);
+      }
+      finally { slaveTasksLocker.ExitReadLock(); }
+    }
+  }
+}
